/**
 * Created by joe.shields
 * Created on 02/07/15
 */

package
{
    import com.app.Main;
    import com.app.models.AssetsModel;

    import flash.display.Sprite;
    import flash.geom.Rectangle;
    import flash.system.Capabilities;
    import flash.filesystem.File;

    import starling.core.Starling;
    import starling.events.Event;
    import starling.textures.RenderTexture;

    import starling.utils.RectangleUtil;
    import starling.utils.ScaleMode;
    import starling.utils.SystemUtil;
    import starling.utils.formatString;

    [SWF(width="1024", height="768", frameRate="60", backgroundColor="#ffffff")]
    public class Init extends Sprite
    {
        private var _starling:Starling;

        public function Init()
        {
            super();

            var stageWidth:int = stage.fullScreenWidth;
            var stageHeight:int = stage.fullScreenHeight
            var iOS:Boolean = SystemUtil.platform == "IOS";
            var stageSize:Rectangle = new Rectangle(0, 0, stageWidth, stageHeight);
            var screenSize:Rectangle = new Rectangle(0, 0, stage.fullScreenWidth, stage.fullScreenHeight);
            var viewPort:Rectangle = RectangleUtil.fit(stageSize, screenSize, ScaleMode.SHOW_ALL);
            var scaleFactor:int = viewPort.width < 480 ? 1 : 2; // midway between 320 and 640

            Starling.multitouchEnabled = true;
            Starling.handleLostContext = true;
            RenderTexture.optimizePersistentBuffers = iOS;

            _starling = new Starling(Main, stage, viewPort, null, "auto", "auto");
            _starling.stage.stageWidth = stageWidth;
            _starling.stage.stageHeight = stageHeight;
            _starling.simulateMultitouch = false;
            _starling.antiAliasing = 1;
            _starling.enableErrorChecking = Capabilities.isDebugger;

            _starling.addEventListener(starling.events.Event.ROOT_CREATED, function():void
            {
                _starling.removeEventListener(starling.events.Event.ROOT_CREATED, function():void{});
                loadAssets(scaleFactor, startApp);
            });

            _starling.start();

        //TODO focus loss
//			if (!SystemUtil.isDesktop)
//			{
//				NativeApplication.nativeApplication.addEventListener(
//					flash.events.Event.ACTIVATE, function (e:*):void { _starling.start(); });
//				NativeApplication.nativeApplication.addEventListener(
//					flash.events.Event.DEACTIVATE, function (e:*):void { _starling.stop(true); });
//			}
        }

        //TODO background image while loading
//		private function initElements(scaleFactor:int):void
//		{
//			// Add background image. By using "loadBytes", we can avoid any flickering.
//
//			var bgPath:String = formatString("textures/{0}x/background.jpg", scaleFactor);
//			var bgFile:File = File.applicationDirectory.resolvePath(bgPath);
//			var bytes:ByteArray = new ByteArray();
//			var stream:FileStream = new FileStream();
//			stream.open(bgFile, FileMode.READ);
//			stream.readBytes(bytes, 0, stream.bytesAvailable);
//			stream.close();
//
//			mBackground = new Loader();
//			mBackground.loadBytes(bytes);
//			mBackground.scaleX = 1.0 / scaleFactor;
//			mBackground.scaleY = 1.0 / scaleFactor;
//			mStarling.nativeOverlay.addChild(mBackground);
//
//			mBackground.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE,
//				function(e:Object):void
//				{
//					(mBackground.content as Bitmap).smoothing = true;
//				});
//
//			// While the assets are loaded, we will display a progress bar.
//
//			mProgressBar = new ProgressBar(175, 20);
//			mProgressBar.x = (StageWidth - mProgressBar.width) / 2;
//			mProgressBar.y =  StageHeight * 0.7;
//			mStarling.nativeOverlay.addChild(mProgressBar);
//		}

        //TODO scale factor and screen resolution management
        private function loadAssets(scaleFactor:int, onComplete:Function):void
        {
            var appDir:File = File.applicationDirectory;

            AssetsModel.getInstance().assets.scaleFactor = 1;

            AssetsModel.getInstance().assets.verbose = false;
            AssetsModel.getInstance().assets.enqueue(
                    appDir.resolvePath("assets/datax"),
                    appDir.resolvePath(formatString("assets/images/{0}x/spritesheet.png", AssetsModel.getInstance().assets.scaleFactor)),
                    appDir.resolvePath(formatString("assets/images/{0}x/spritesheet.xml", AssetsModel.getInstance().assets.scaleFactor))
            );

            AssetsModel.getInstance().assets.loadQueue(function(ratio:Number):void
            {
                if (ratio == 1) onComplete();
            });
        }

        private function startApp():void
        {
            //trace(AssetsModel.getInstance().assets.getXml("data").sound[0].@title);

            var main:Main = _starling.root as Main;
            main.start();
        }
    }
}
